Subject: Re: [tram] Adoption of draft-reddy-tram-stun-path-data-01

From: "Tirumaleswar Reddy (tireddy)" <[email-masked]>
Date: Tue, 31 Mar 2015 12:23:00 +0000

> -----Original Message-----
> From: tram [mailto:[email-masked]] On Behalf Of Oleg Moskalenko
> Sent: Tuesday, March 31, 2015 12:25 PM
> To: Martin Thomson
> Cc: Simon Perreault; [email-masked]
> Subject: Re: [tram] Adoption of draft-reddy-tram-stun-path-data-01
> 
> I agree with Martin that the PATH-CHARACTERISTIC attribute is confusing:
> 
> 1) In the request it has 4 bytes (1+3), in the response in has 8 bytes
> (2+2+2+2) - that is bizarre. It would be a good style to keep the attribute of
> the same size and structure, regardless of the attribute placement.
> 2) The server is never doing any retransmissions for the responses; all
> retransmissions in STUN are responsibility of the client. So, the ReqTransCnt
> and RespTransCnt are always equal. The number of received requests is
> always equal to the number of responses. So, why do we need two separate
> fields for the same value ?
> 3) Why ReTransCnt in the request occupies 1 bytes, but in the response the
> same value takes 2 bytes ? That is very strange.

Agreed on all the above points; will update the format of PATH-CHARACTERISTIC attribute as follows:

       0                   1                   2                   3
       0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
      |           Reserved, should be 0 |  ReTransCnt |  RespTransCnt |
      +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

RespTransCnt must be set to zero in request and ignored by the server.
RespTransCnt could be zero in response (e.g. server is stateless).

> 
> I agree with the usefulness of the approach and I think that the draft has to
> be adopted 

Thanks,
-Tiru

> - but those things to be clarified before the adoption.
> 
> Thanks
> Oleg
> 
> 
> On Mon, Mar 30, 2015 at 12:55 PM, Martin Thomson
> <[email-masked]> wrote:
> > On 27 March 2015 at 08:35, Simon Perreault <[email-masked]> wrote:
> >> This is to confirm the adoption of draft-reddy-tram-stun-path-data-01
> >> as a working group draft. If anyone is opposed, now is a good time to
> >> explain why.
> >
> > This looks fine in general, with one issue:
> >
> > Issue:
> > ReTransCnt, ReqTransCnt and RespTransCnt are so similar that this is
> > very confusing.  When I finally parsed this, I realize that the server
> > isn't going to have three piece of information; it only needs to a)
> > echo the client's counter, and b) (if stateful) indicate how many
> > times it has responded over time.  As specified, I can't see any way
> > that having the number of received messages being different to the
> > number of responses is of any value.
> >
> > Finally, I think that you should specify a more regular form for the
> > parameter.  One byte of Client Retransmission Counter, and one byte of
> > Server Retransmission Counter should be easy to understand.  Zero
> > being an indication that the sender didn't want to say for any reason,
> > as currently specified.
> >
> > Nit:
> >    These metrics can then be used
> >    by the controlling agent to influence the ICE candidate pair
> >    priorities.
> > Changing priorities is not possible, changing what might be selected is.
> >
> > _______________________________________________
> > tram mailing list
> > [email-masked]
> > https://www.ietf.org/mailman/listinfo/tram
> 
> _______________________________________________
> tram mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/tram

---

From: Oleg Moskalenko <[email-masked]>
Date: Tue, 31 Mar 2015 08:59:26 -0700

> Agreed on all the above points; will update the format of PATH-CHARACTERISTIC attribute as follows:

That's cool. I support the adoption.

Thanks
Oleg